# filters.csf

The Cloth Simulation Filter (CSF) classifies ground points based on the approach outlined in [Zhang2016].

Default Embedded Stage

This stage is enabled by default

## Example

The sample pipeline below uses CSF to segment ground and non-ground returns, using default options, and writing only the ground returns to the output file.

    [
        "input.las",
        {
            "type":"filters.csf"
        },
        {
            "type":"filters.range",
            "limits":"Classification[2:2]"
        },
        "output.laz"
    ]

## Options

resolution

  Cloth resolution. [Default: 1.0]

ignore

  A range of values of a dimension to ignore.

returns

  Return types to include in output. Valid values are “first”, “last”, “intermediate” and “only”. [Default: “last, only”]

threshold

  Classification threshold. [Default: 0.5]

smooth

  Perform slope post-processing? [Default: true]

step

  Time step. [Default: 0.65]

rigidness

  Rigidness. [Default: 3]

iterations

  Maximum number of iterations. [Default: 500]

where

  An expression that limits points passed to a filter. Points that don’t pass the expression skip the stage but are available to subsequent stages in a pipeline. [Default: no filtering]

where_merge

  A strategy for merging points skipped by a ‘where’ option when running in standard mode. If `true`, the skipped points are added to the first point view returned by the skipped filter. If `false`, skipped points are placed in their own point view. If `auto`, skipped points are merged into the returned point view provided that only one point view is returned and it has the same point count as it did when the filter was run. [Default: `auto`]